diff --git a/engines/pegasus/neighborhood/caldoria/caldoria.cpp b/engines/pegasus/neighborhood/caldoria/caldoria.cpp
index 0707a83..0cb7f22 100644
--- a/engines/pegasus/neighborhood/caldoria/caldoria.cpp
+++ b/engines/pegasus/neighborhood/caldoria/caldoria.cpp
@@ -1518,7 +1939,51 @@ void Caldoria::clickOnDoorbell(const HotSpotID doorBellSpotID) {
 
 	getExtraEntry(extra, entry);
 	showViewFrame(entry.movieStart);
-	requestSpotSound(kCaldoriaNobodyHomeIn, kCaldoriaNobodyHomeOut, kFilterNoInput, kSpotSoundCompletedFlag);
+	if (_vm->isDVD() && doorBellSpotID != kCaldoria34DoorbellSpotID && doorBellSpotID != kCaldoria35DoorbellSpotID) {
+		_vm->_cursor->hide();
+		doorbellSound.setVolume(_vm->getSoundFXLevel());
+		doorbellSound.playSound();
+		while (doorbellSound.isPlaying() && !_vm->shouldQuit()) {
+			InputDevice.getInput(input, kFilterNoInput);
+
+			_vm->checkCallBacks();
+			_vm->refreshDisplay();
+			_vm->_system->delayMillis(10);
+		}
+		if (_vm->shouldQuit())
+			return;
+		_vm->_cursor->hideUntilMoved();
+		updateViewFrame();
+	} else {
+		requestSpotSound(kCaldoriaNobodyHomeIn, kCaldoriaNobodyHomeOut, kFilterNoInput, kSpotSoundCompletedFlag);
+	}
+}
+
+void Caldoria::cantMoveThatWay(CanOpenDoorReason reason) {
+	switch (reason) {
+	case kCantMoveDoorClosed:
+	case kCantMoveDoorLocked:
+		openDoor();
+		break;
+	case kCantMoveBlocked:
+		switch (GameState.getCurrentRoomAndView()) {
+		case MakeRoomView(kCaldoria20, kWest):
+		case MakeRoomView(kCaldoria21, kEast):
+		case MakeRoomView(kCaldoria26, kSouth):
+		case MakeRoomView(kCaldoria29, kSouth):
+		case MakeRoomView(kCaldoria34, kWest):
+		case MakeRoomView(kCaldoria35, kEast):
+			cantOpenDoor(kCantOpenLocked);
+			break;
+		default:
+			zoomUpOrBump();
+			break;
+		}
+		break;
+	default:
+		bumpIntoWall();
+		break;
+	}
 }
 
 CanOpenDoorReason Caldoria::canOpenDoor(DoorTable::Entry &entry) {
@@ -1606,6 +2071,9 @@ void Caldoria::pickedUpItem(Item *item) {
 }
 
 void Caldoria::dropItemIntoRoom(Item *item, Hotspot *dropSpot) {
+	Input input;
+	Sound cardBombVoice;
+
 	switch (item->getObjectID()) {
 	case kKeyCard:
 		Neighborhood::dropItemIntoRoom(item, dropSpot);
@@ -1629,7 +2097,26 @@ void Caldoria::dropItemIntoRoom(Item *item, Hotspot *dropSpot) {
 		_utilityFuse.lightFuse();
 		GameState.setCaldoriaFuseTimeLimit(kCardBombCountDownTime);
 		loopCroppedMovie("Images/Caldoria/A48 Bomb Loop", kCaldoria48CardBombLoopLeft, kCaldoria48CardBombLoopTop);
+		if (_vm->isDVD()) {
+			InputDevice.getInput(input, kFilterAllInput);
+			if (JMPPPInput::isEasterEggModifierInput(input))
+				cardBombVoice.initFromAIFFFile("Sounds/Caldoria/Card Bomb.Geno.aiff");
+			else
+				cardBombVoice.initFromAIFFFile("Sounds/Caldoria/Card Bomb.44K.aiff");
+			cardBombVoice.playSound();
+			while (cardBombVoice.isPlaying() && !_vm->shouldQuit()) {
+				InputDevice.getInput(input, kFilterNoInput);
+
+				_vm->checkCallBacks();
+				_vm->refreshDisplay();
+				_vm->_system->delayMillis(10);
+			}
+			if (_vm->shouldQuit())
+				return;
+		}
 		GameState.setScoringUsedCardBomb(true);
+		if (g_arthurChip)
+			g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA19", kArthurCaldoriaUsedCardBomb);
 		break;
 	case kStunGun:
 		GameState.setCaldoriaGunAimed(true);
@@ -1640,6 +2127,8 @@ void Caldoria::dropItemIntoRoom(Item *item, Hotspot *dropSpot) {
 		_gunSprite->moveElementTo(kCaldoriaGunSpriteLeft, kCaldoriaGunSpriteTop);
 		_gunSprite->startDisplaying();
 		_gunSprite->show();
+		if (g_arthurChip)
+			g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA17", kArthurCaldoriaStunningSinclair);
 		break;
 	default:
 		Neighborhood::dropItemIntoRoom(item, dropSpot);
@@ -1647,6 +2136,35 @@ void Caldoria::dropItemIntoRoom(Item *item, Hotspot *dropSpot) {
 	}
 }
 
+void Caldoria::playMissingFloorSound() {
+	Input input;
+	Sound elevatorVoice;
+
+	InputDevice.getInput(input, kFilterAllInput);
+	if (_vm->isDVD() && JMPPPInput::isEasterEggModifierInput(input)) {
+		_vm->_cursor->hide();
+		elevatorVoice.initFromAIFFFile("Sounds/Caldoria/Elevator Denied.32K.aiff");
+		elevatorVoice.setVolume(_vm->getSoundFXLevel());
+		elevatorVoice.playSound();
+		while (elevatorVoice.isPlaying() && !_vm->shouldQuit()) {
+			InputDevice.getInput(input, kFilterNoInput);
+
+			_vm->checkCallBacks();
+			_vm->refreshDisplay();
+			_vm->_system->delayMillis(10);
+		}
+		if (_vm->shouldQuit())
+			return;
+		_vm->_cursor->hideUntilMoved();
+		updateElevatorMovie();
+	} else {
+		requestSpotSound(kCaldoriaNoOtherFloorIn,
+							kCaldoriaNoOtherFloorOut,
+							kFilterNoInput,
+							kSpotSoundCompletedFlag);
+	}
+}
+
 void Caldoria::takeElevator(uint startFloor, uint endFloor) {
 	_croppedMovie.stop();
 	_croppedMovie.setSegment(0, _croppedMovie.getDuration());
@@ -1660,12 +2178,12 @@ void Caldoria::takeElevator(uint startFloor, uint endFloor) {
 		case 2:
 			_croppedMovie.setTime(k1To2Time);
 			_croppedMovie.redrawMovieWorld();
-			requestSpotSound(kCaldoriaNoOtherDestinationIn, kCaldoriaNoOtherDestinationOut, kFilterNoInput, kSpotSoundCompletedFlag);
+			playMissingFloorSound();
 			break;
 		case 3:
 			_croppedMovie.setTime(k1To3Time);
 			_croppedMovie.redrawMovieWorld();
-			requestSpotSound(kCaldoriaNoOtherDestinationIn, kCaldoriaNoOtherDestinationOut, kFilterNoInput, kSpotSoundCompletedFlag);
+			playMissingFloorSound();
 			break;
 		case 4:
 			_croppedMovie.setSegment(k1To4Start, k1To4Stop);
@@ -1692,12 +2210,12 @@ void Caldoria::takeElevator(uint startFloor, uint endFloor) {
 		case 2:
 			_croppedMovie.setTime(k4To2Time);
 			_croppedMovie.redrawMovieWorld();
-			requestSpotSound(kCaldoriaNoOtherDestinationIn, kCaldoriaNoOtherDestinationOut, kFilterNoInput, kSpotSoundCompletedFlag);
+			playMissingFloorSound();
 			break;
 		case 3:
 			_croppedMovie.setTime(k4To3Time);
 			_croppedMovie.redrawMovieWorld();
-			requestSpotSound(kCaldoriaNoOtherDestinationIn, kCaldoriaNoOtherDestinationOut, kFilterNoInput, kSpotSoundCompletedFlag);
+			playMissingFloorSound();
 			break;
 		case 4:
 			// Do nothing.
@@ -1721,12 +2239,12 @@ void Caldoria::takeElevator(uint startFloor, uint endFloor) {
 		case 2:
 			_croppedMovie.setTime(k5To2Time);
 			_croppedMovie.redrawMovieWorld();
-			requestSpotSound(kCaldoriaNoOtherDestinationIn, kCaldoriaNoOtherDestinationOut, kFilterNoInput, kSpotSoundCompletedFlag);
+			playMissingFloorSound();
 			break;
 		case 3:
 			_croppedMovie.setTime(k5To3Time);
 			_croppedMovie.redrawMovieWorld();
-			requestSpotSound(kCaldoriaNoOtherDestinationIn, kCaldoriaNoOtherDestinationOut, kFilterNoInput, kSpotSoundCompletedFlag);
+			playMissingFloorSound();
 			break;
 		case 4:
 			_croppedMovie.setSegment(k5To4Start, k5To4Stop);
@@ -1984,4 +2502,66 @@ Common::String Caldoria::getSoundSpotsName() {
 	return "Sounds/Caldoria/Caldoria Spots";
 }
 
+void Caldoria::doArthurJoyride() {
+	Video::VideoDecoder *video = 0;
+	BiochipItem *item;
+
+	setNextHandler(_vm);
+	throwAwayInterface();
+	loadLoopSound1("");
+
+	_vm->_cursor->hide();
+
+#ifdef USE_THEORADEC
+	video = new Video::TheoraDecoder();
+	if (!video->loadFile("Images/Caldoria/A12RD.ogg")) {
+		delete video;
+		video = 0;
+	}
+#endif
+
+	if (!video) {
+		video = new Video::QuickTimeDecoder();
+		if (!video->loadFile("Images/Caldoria/A12RD.movie"))
+			error("Could not load joyride video");
+	}
+
+	video->setVolume(MIN<uint>(_vm->getSoundFXLevel(), 0xFF));
+	video->start();
+
+	while (!_vm->shouldQuit() && !video->endOfVideo()) {
+		if (video->needsUpdate()) {
+			const Graphics::Surface *frame = video->decodeNextFrame();
+
+			if (frame) {
+				g_system->copyRectToScreen((const byte *)frame->getPixels(), frame->pitch, 0, 0, frame->w, frame->h);
+				g_system->updateScreen();
+			}
+		}
+
+		Common::Event event;
+		while (g_system->getEventManager()->pollEvent(event))
+			;
+
+		g_system->delayMillis(10);
+	}
+
+	delete video;
+
+	if (_vm->shouldQuit())
+		return;
+
+	reinstateMonocleInterface();
+	loadAmbientLoops();
+	updateViewFrame();
+	if (!_vm->playerHasItemID(kArthurBiochip)) {
+		item = (BiochipItem *)_vm->getAllItems().findItemByID(kArthurBiochip);
+		_vm->addItemToBiochips(item);
+		if (g_arthurChip)
+			g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA06", kArthurCaldoriaFinishedJoyride);
+	}
+	g_interface->setCurrentBiochipID(kArthurBiochip);
+	GameState.setEasterEgg(false);
+}
+
 } // End of namespace Pegasus
diff --git a/engines/pegasus/neighborhood/caldoria/caldoria.h b/engines/pegasus/neighborhood/caldoria/caldoria.h
index 3d6a155..982789f 100644
--- a/engines/pegasus/neighborhood/caldoria/caldoria.h
+++ b/engines/pegasus/neighborhood/caldoria/caldoria.h
@@ -195,6 +195,7 @@ static const HotSpotID kCaldoriaRoofElevatorSpotID = 5065;
 static const HotSpotID kCaldoriaRoofDoorSpotID = 5066;
 static const HotSpotID kCaldoriaRoofCardDropSpotID = 5067;
 static const HotSpotID kCaldoria53EastSinclairTargetSpotID = 5068;
+static const HotSpotID kCaldoriaCornbread = 5069;
 
 // Extra sequence IDs.
 
@@ -383,6 +384,9 @@ static const DisplayElementID kCaldoriaUtilityID = kCaldoriaMessagesID + 1;
 static const DisplayElementID kCaldoriaBombGridID = kCaldoriaUtilityID + 1;
 static const DisplayElementID kCaldoriaBombTimerID = kCaldoriaBombGridID + 1;
 
+static const TimeValue kCaldoria4DInstructionsIn = 28013;
+static const TimeValue kCaldoria4DInstructionsOut = 29730;
+
 static const TimeValue kCaldoria4DBlankChoiceIn = 29730;
 static const TimeValue kCaldoria4DBlankChoiceOut = 33910;
 
@@ -445,6 +449,7 @@ protected:
 
 	void init();
 	void start();
+	void throwAwayInterface();
 
 	void setUpRoofTop();
 
@@ -472,7 +477,10 @@ protected:
 	void arriveAtCaldoriaDeath();
 	void turnTo(const DirectionConstant);
 	void zoomTo(const Hotspot *);
+	void leftButton(const Input &);
+	void rightButton(const Input &);
 	void downButton(const Input &);
+	void startExtraSequence(const ExtraID, const NotificationFlags, const InputBits);
 	void receiveNotification(Notification *, const NotificationFlags);
 	InputBits getInputFilter();
 	void activateHotspots();
@@ -483,6 +491,7 @@ protected:
 
 	Hotspot *getItemScreenSpot(Item *, DisplayElement *);
 	void dropItemIntoRoom(Item *, Hotspot *);
+	void playMissingFloorSound();
 	void takeElevator(uint, uint);
 	void updateElevatorMovie();
 	void openElevatorMovie();
@@ -495,7 +504,9 @@ protected:
 	void zoomToSinclair();
 	void playEndMessage();
 	void checkInterruptSinclair();
+	void doArthurJoyride();
 
+	void cantMoveThatWay(CanMoveForwardReason);
 	CanOpenDoorReason canOpenDoor(DoorTable::Entry &);
 	void doorOpened();
 
@@ -505,6 +516,15 @@ protected:
 
 	const Hotspot *_zoomOutSpot;
 
+	Hotspot _laundryZoomInSpot;
+	Hotspot _laundryZoomOutSpot;
+	Hotspot _cornbreadSpot;
+
+	Movie _extraMovie;
+	NotificationCallBack _extraMovieCallBack;
+
+	bool _lookingAtLaundry;
+
 	FuseFunction _utilityFuse;
 
 	long _sinclairLoopCount;
diff --git a/engines/pegasus/neighborhood/caldoria/caldoria4dsystem.cpp b/engines/pegasus/neighborhood/caldoria/caldoria4dsystem.cpp
index 0494753..a4b0276 100644
--- a/engines/pegasus/neighborhood/caldoria/caldoria4dsystem.cpp
+++ b/engines/pegasus/neighborhood/caldoria/caldoria4dsystem.cpp
@@ -210,7 +210,8 @@ void Caldoria4DSystem::useIdleTime() {
 void Caldoria4DSystem::initInteraction() {
 	setSpritesMovie();
 
-	_owner->loadLoopSound1("Sounds/Caldoria/Rock.aiff");
+	playSound("Rock");
+	_owner->playSpotSoundSync(kCaldoria4DInstructionsIn, kCaldoria4DInstructionsOut);
 	loopExtra(k4DIslandLoop);
 }
 
@@ -243,8 +244,7 @@ void Caldoria4DSystem::handleInput(const Input &input, const Hotspot *cursorSpot
 
 void Caldoria4DSystem::activateHotspots() {
 	GameInteraction::activateHotspots();
-	if (_whichMenu == k4DAudioMenu)
-		g_allHotspots.activateOneHotspot(kCa4DChoice4SpotID);
+	g_allHotspots.activateOneHotspot(kCa4DChoice4SpotID);
 }
 
 void Caldoria4DSystem::clickInHotspot(const Input &input, const Hotspot *spot) {
@@ -335,7 +335,7 @@ void Caldoria4DSystem::makeRockChoice() {
 	if (_audioChoice != k4DRockChoice) {
 		_audioChoice = k4DRockChoice;
 		setSpritesMovie();
-		_owner->loadLoopSound1("Sounds/Caldoria/Rock.aiff");
+		playSound("Rock");
 	}
 }
 
@@ -343,7 +343,7 @@ void Caldoria4DSystem::makeOrchestralChoice() {
 	if (_audioChoice != k4DOrchestralChoice) {
 		_audioChoice = k4DOrchestralChoice;
 		setSpritesMovie();
-		_owner->loadLoopSound1("Sounds/Caldoria/Orchestral.aiff");
+		playSound("Orchestral");
 	}
 }
 
@@ -351,7 +351,7 @@ void Caldoria4DSystem::makeRhythmsChoice() {
 	if (_audioChoice != k4DRhythmsChoice) {
 		_audioChoice = k4DRhythmsChoice;
 		setSpritesMovie();
-		_owner->loadLoopSound1("Sounds/Caldoria/Rhythms.aiff");
+		playSound("Rhythms");
 	}
 }
 
@@ -359,7 +359,7 @@ void Caldoria4DSystem::makeAcousticChoice() {
 	if (_audioChoice != k4DAcousticChoice) {
 		_audioChoice = k4DAcousticChoice;
 		setSpritesMovie();
-		_owner->loadLoopSound1("Sounds/Caldoria/Acoustic.aiff");
+		playSound("Acoustic");
 	}
 }
 
@@ -367,4 +367,14 @@ void Caldoria4DSystem::shutDown4DSystem() {
 	_whichMenu = k4DShuttingDown;
 }
 
+void Caldoria4DSystem::playSound(const Common::String &baseFileName) {
+	Common::String fileName = "Sounds/Caldoria/" + baseFileName;
+
+	// Updated DVD files
+	if (((PegasusEngine *)g_engine)->isDVD())
+		fileName += ".44K";
+
+	_owner->loadLoopSound1(fileName + ".aiff");
+}
+
 } // End of namespace Pegasus
diff --git a/engines/pegasus/neighborhood/caldoria/caldoria4dsystem.h b/engines/pegasus/neighborhood/caldoria/caldoria4dsystem.h
index 1c5fa44..0d57d7c 100644
--- a/engines/pegasus/neighborhood/caldoria/caldoria4dsystem.h
+++ b/engines/pegasus/neighborhood/caldoria/caldoria4dsystem.h
@@ -63,6 +63,8 @@ protected:
 	void useIdleTime();
 	void loopExtra(const ExtraID);
 
+	void playSound(const Common::String &baseFileName);
+
 	Movie _4DSpritesMovie;
 	TimeScale _4DSpritesScale;
 	uint _whichMenu;
diff --git a/engines/pegasus/neighborhood/caldoria/caldoriabomb.cpp b/engines/pegasus/neighborhood/caldoria/caldoriabomb.cpp
index abf34d3..adfd77d 100644
--- a/engines/pegasus/neighborhood/caldoria/caldoriabomb.cpp
+++ b/engines/pegasus/neighborhood/caldoria/caldoriabomb.cpp
@@ -25,6 +25,7 @@
 
 #include "pegasus/gamestate.h"
 #include "pegasus/pegasus.h"
+#include "pegasus/items/biochips/arthurchip.h"
 #include "pegasus/neighborhood/caldoria/caldoria.h"
 #include "pegasus/neighborhood/caldoria/caldoriabomb.h"
 
@@ -48,7 +49,9 @@ static const uint32 kOnTime3 = kOffTime2 + kFlashOnTime;
 static const uint32 kOffTime3 = kOnTime3 + kFlashOffTime;
 static const uint32 kOnTime4 = kOffTime3 + kFlashOnTime;
 
-static const HotSpotID kVertextHotSpotBaseID = 10000;
+// Bomb hotspots start at 20000 since the extra Caldoria hotspots start at 10000.
+// Assigning these vice versa causes a hotspot in level 4 to never activate for some reason.
+static const HotSpotID kVertextHotSpotBaseID = 20000;
 
 static const CoordType kVertextHotSpotWidth = 24;
 static const CoordType kVertextHotSpotHeight = 24;
@@ -1235,6 +1238,12 @@ void CaldoriaBomb::receiveNotification(Notification *notification, const Notific
 			_currentLevel = 0;
 			_lastVertex = -1;
 			startBombAmbient("Sounds/Caldoria/BmbLoop1.22K.AIFF");
+			if (g_arthurChip) {
+				if (((PegasusEngine *)g_engine)->getRandomBit())
+					g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA14", kArthurCaldoriaSeeRoofBomb);
+				else
+					g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBB28", kArthurCaldoriaSeeRoofBomb);
+			}
 			break;
 		case kCaldoria56BombStage2:
 		case kCaldoria56BombStage3:
@@ -1412,6 +1421,8 @@ void CaldoriaBomb::handleInput(const Input &input, const Hotspot *hotspot) {
 				_grid.hide();
 				_timer.hide();
 				_owner->startExtraSequence(kCaldoria56BombStage7, kExtraCompletedFlag, kFilterNoInput);
+				if (g_arthurChip)
+					g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA02", kArthurCaldoriaDisarmedNuke);
 				break;
 			}
 		}
diff --git a/engines/pegasus/neighborhood/caldoria/caldoriamirror.cpp b/engines/pegasus/neighborhood/caldoria/caldoriamirror.cpp
index ff4d181..9f487cb 100644
--- a/engines/pegasus/neighborhood/caldoria/caldoriamirror.cpp
+++ b/engines/pegasus/neighborhood/caldoria/caldoriamirror.cpp
@@ -25,6 +25,7 @@
 
 #include "pegasus/gamestate.h"
 #include "pegasus/pegasus.h"
+#include "pegasus/items/biochips/arthurchip.h"
 #include "pegasus/neighborhood/neighborhood.h"
 #include "pegasus/neighborhood/caldoria/caldoria.h"
 #include "pegasus/neighborhood/caldoria/caldoriamirror.h"
@@ -42,6 +43,11 @@ void CaldoriaMirror::openInteraction() {
 void CaldoriaMirror::initInteraction() {
 	_owner->setCurrentActivation(kActivateMirrorReady);
 	_owner->startExtraSequence(kCaBathroomGreeting, kExtraCompletedFlag, kFilterNoInput);
+	// The original made the player click to start each of the following sequences,
+	// which was unnecessary, so it is automated here.
+	_owner->startExtraSequenceSync(kCaBathroomGreeting, kFilterNoInput);
+	_owner->startExtraSequenceSync(kCaBathroomBodyFat, kFilterNoInput);
+	_owner->startExtraSequence(kCaBathroomStylistIntro, kExtraCompletedFlag, kFilterNoInput);
 }
 
 void CaldoriaMirror::closeInteraction() {
@@ -79,30 +85,18 @@ void CaldoriaMirror::activateHotspots() {
 
 void CaldoriaMirror::clickInHotspot(const Input &input, const Hotspot *spot) {
 	switch (spot->getObjectID()) {
-	case kCaBathroomMirrorSpotID:
-		switch (_owner->getLastExtra()) {
-		case kCaBathroomGreeting:
-			_owner->startExtraSequence(kCaBathroomBodyFat, kExtraCompletedFlag, kFilterNoInput);
-			break;
-		case kCaBathroomBodyFat:
-			_owner->startExtraSequence(kCaBathroomStylistIntro, kExtraCompletedFlag, kFilterNoInput);
-			break;
-		case kCaBathroomRetrothrash:
-			_owner->startExtraSequence(kCaBathroomRetrothrashReturn, kExtraCompletedFlag, kFilterNoInput);
-			break;
-		case kCaBathroomGeoWave:
-			_owner->startExtraSequence(kCaBathroomGeoWaveReturn, kExtraCompletedFlag, kFilterNoInput);
-			break;
-		}
-		break;
+	// The original made the player click through several interstitial screens before
+	// reaching the hairstyle menu, which was unnecessary, so it's skipped here.
 	case kCaHairStyle1SpotID:
-		_owner->startExtraSequence(kCaBathroomRetrothrash, kExtraCompletedFlag, kFilterNoInput);
+		_owner->startExtraSequenceSync(kCaBathroomRetrothrash, kFilterNoInput);
+		_owner->startExtraSequence(kCaBathroomRetrothrashReturn, kExtraCompletedFlag, kFilterNoInput);
 		break;
 	case kCaHairStyle2SpotID:
 		_owner->startExtraSequence(kCaBathroomAgencyStandard, kExtraCompletedFlag, kFilterNoInput);
 		break;
 	case kCaHairStyle3SpotID:
-		_owner->startExtraSequence(kCaBathroomGeoWave, kExtraCompletedFlag, kFilterNoInput);
+		_owner->startExtraSequenceSync(kCaBathroomGeoWave, kFilterNoInput);
+		_owner->startExtraSequence(kCaBathroomGeoWaveReturn, kExtraCompletedFlag, kFilterNoInput);
 		break;
 	default:
 		GameInteraction::clickInHotspot(input, spot);
@@ -126,10 +120,10 @@ void CaldoriaMirror::receiveNotification(Notification *, const NotificationFlags
 		_owner->requestDeleteCurrentInteraction();
 		GameState.setScoringFixedHair(true);
 		GameState.setCaldoriaDoneHygiene(true);
+		if (g_arthurChip)
+			g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA43", kArthurCaldoriaChoseAgencyHairStyle);
 		break;
 	}
-
-	allowInput(true);
 }
 
 } // End of namespace Pegasus
